#ifndef MB_REGS_F_LIB_H_
#define MB_REGS_F_LIB_H_

#include "platform.h"

#define MAX_QUANTITY_HOLDING_REGS 64u 
#define MAX_QUANTITY_INPUT_REGS 16u 
#define MAX_QUANTITY_INPUT_DISCRETE_REGS 16u 
#define MAX_QUANTITY_COLIS_REGS 16u 
#define TYPE_LINE_LEN uint8_t //ставить в зависимости от MAX_QUANTITY_HOLDING_REGS

typedef enum
{
	MBR_holding = 0u,
	MBR_input = 1u,
	MBR_input_discrete = 2u,
	MBR_coils = 3u,
} MBR_reg_type;

typedef enum
{
  MBR_OK       = 0x00U,
  MBR_ERROR    = 0x01U,
  MBR_LEN_ERROR    = 0x02U,
  MBR_CEATE_DISABLE = 0x03U,
  MBR_ADDR_ERROR = 0x04U, //в случае если адресс повторяется
} MBR_status;

void MBRF_init_start(void);
MBR_status MBRF_init_end(void);
MBR_status MBRF_create_reg(uint16_t addr, uint16_t* data, MBR_reg_type reg_type);
MBR_status MBRF_read_reg(uint16_t read_addr, uint16_t* return_data, MBR_reg_type reg_type);
MBR_status MBRF_write_reg(uint16_t addr, uint16_t data, MBR_reg_type reg_type);
MBR_status MBRF_multiple_read_reg(uint16_t read_addr_start, uint16_t reg_len, uint8_t* return_data, MBR_reg_type reg_type);
MBR_status MBRF_multiple_read_reg_bool(uint16_t read_addr_start, uint16_t reg_len, uint8_t* return_data, MBR_reg_type reg_type);

#ifdef UTEST_BUILD
void MBRF_clear_file(void);
TYPE_LINE_LEN MBRF_MAX_QUANTITY(MBR_reg_type reg_type);
#endif

#endif