/**
  ******************************************************************************
  * @file    state_machine.c
  * @brief   функции для удобной работы втутри бесонечного цикла
  ******************************************************************************
  */

#include "platform.h"
#include "sys_tim.h"
#include "state_machine.h"

/**
   @brief "исполнить" текущее состояние
   @param dev 
 */
void execute_current_state(state_machine_dev* dev)
{
	if(dev->current_state!=0u) //проверка в 3х метсах, пусть будет 
	{
		dev->current_state(dev);
	}
}

/**
   @brief "неблокирущая" задержка))
   @param dev 
 */
void delay_state(state_machine_dev* dev) 
{
	if(time_get_ms()>=(dev->delay_cnt))
	{
		dev->current_state=dev->state_after_delay;
	}
	return;
}

/**
   @brief установить состояние
   @param state  указатель на фунцию 
   @param dev 
 */
void set_state(program_state state, state_machine_dev* dev)
{
	if(state!=0u) 
	{
		dev->current_state = state;
	}
	return;
}

/**
   @brief установить состояние после задержи
   @param state  указатель на фунцию 
   @delay_ms задержка в ms
   @param dev 
 */
void set_state_after_delay(program_state state, uint32_t delay_ms, state_machine_dev* dev) 
{
	if(state!=0u)
	{
		dev->state_after_delay = state;
		dev->delay_cnt = time_get_ms()+delay_ms;
		dev->current_state = delay_state;
	}
	return;
}

/**
   @brief заглушка
 */
void plug_state(state_machine_dev* dev)
{
	return;
}