#ifndef STATE_MACHINE_H_
#define STATE_MACHINE_H_

typedef struct{
	void (*current_state)(uint32_t*); //указатель на program_state
	void (*state_after_delay)(uint32_t*); //указатель на program_state
	uint32_t delay_cnt;
}state_machine_dev;

typedef void (*program_state)(state_machine_dev*);

void execute_current_state(state_machine_dev* dev);
void delay_state(state_machine_dev*);
void plug_state(state_machine_dev* dev);
void set_state(program_state state, state_machine_dev*);
void set_state_after_delay(program_state state, uint32_t delay_ms, state_machine_dev*);

#endif
