#include "platform.h"
#include "dout.h"
#include "modbus_regs_file.h"
#include "modbus_config.h"

static uint16_t dout_state_flag = MBDDATA_STATE_DOUT;

/**
   @brief инициализируем пин
 */
void dout_init(void)
{


	RCC   -> IOPENR  |= RCC_IOPENR_GPIOAEN ;

	GPIOA -> MODER   &= ~GPIO_MODER_MODE1_1;
	GPIOA -> MODER   |= GPIO_MODER_MODE1_0; //General purpose output mode

	GPIOA -> OTYPER  |=GPIO_OTYPER_OT1; //Output push-pul

	GPIOA -> OSPEEDR &= ~GPIO_OSPEEDR_OSPEED1_1;
	GPIOA -> OSPEEDR &= ~GPIO_OSPEEDR_OSPEED1_0; //Very low speed

	GPIOA -> PUPDR   &= ~ GPIO_PUPDR_PUPD1_1;  //No pull-up, pull-down
	GPIOA -> PUPDR   |=GPIO_PUPDR_PUPD1_0;

	dout_set(dout_state_flag);
	return;
}

/**
   @brief переключить состояние 
   @note меняет начение модбас регистра
 */
void dout_set(bool state)
{
	if(state!=DOUT_CLOSED){
		GPIOA -> ODR |=GPIO_ODR_OD1;
		dout_state_flag = DOUT_OPEN;
	}else{
		GPIOA -> ODR &= ~GPIO_ODR_OD1;
		dout_state_flag = DOUT_CLOSED;
	}
	return;
}

/**
   @brief получить текущее состояние
 */
bool dout_get(void)
{
	return !(dout_state_flag!=DOUT_CLOSED);
}


/**
   @brief работаем
 */
void dout_periodic_work(void)
{
	dout_set(TO_BOOL(dout_state_flag));
}


/**
   @brief передаём указатели в модбас
 */
uint8_t MBRF_dout_init(void)
{
	return  MBRF_create_reg(MBADDR_STATE_DOUT, &dout_state_flag, MBTYPE_STATE_DOUT); //0x0012
}
