#ifndef I2C_PLIB_H_
#define I2C_PLIB_H_

#include "platform.h"
#include "bool.h"

typedef enum
{
	I2C_BUSY,
	I2C_NOT_BUSY,
	I2C_LENGTH_ERROR,
	I2C_NACK,
	I2C_ACK,
	I2C_OK,
	I2C_ERROR
} i2c_status;

i2c_status i2c_init(void);
i2c_status i2c_read(uint8_t addr, uint8_t* data, uint8_t length);
i2c_status i2c_write(uint8_t addr, uint8_t* data,uint8_t length);

i2c_status i2c_check_last_transmit_ACK(void);
i2c_status i2c_check_busy(void); 

i2c_status i2c_lock_read(uint8_t addr, uint8_t* data, uint8_t length);
i2c_status i2c_lock_write(uint8_t addr, uint8_t* data,uint8_t length);

#endif
