/**
  ******************************************************************************
  * @file    uart_modbus.c
  * @brief   modbus lol level func
  * @note    тут всё в процессе, очень грязно код написан, нужно рефакторинг глубокий
  * @note    разбить на 2 файла, чтоб логика и работа с регистрами МК была отдельна
  * @note    так же нужно добавить функциокал (отслеживание пропусков 1.5ch и т.д.)
  * @note    "логическую" часть покрыть тестами и к misrac всё привести
  ******************************************************************************
*/

#include "platform.h"
#include "uart_modbus.h"
#include "sys_tim.h"
#include "crc.h"
#include "modbus_regs_file.h"
#include "modbus_config.h"

#include "led.h"//delete
#include "dout.h"

static void MB_DMA_tx_start(uint16_t len);
static void MB_DMA_rx_start(uint16_t len);
static void MB_response_handler(bool unicast_flag);
extern void DMA1_Channel1_IRQHandler(void);
extern void DMA1_Channel2_3_IRQHandler(void);
extern void USART1_IRQHandler(void);
static uint8_t MB_make_frame_eror(uint8_t er_code);
static uint8_t MB_make_frame_w(MBR_reg_type reg_type);
static uint8_t MB_make_frame_r_bool(MBR_reg_type reg_type);
static uint8_t MB_make_frame_r_u16(MBR_reg_type reg_type);
static bool MB_check_request(bool *unicast_flag);
static void RE_DE_set_pin(bool state);
static void RE_DE_init_pin(void);
static uint32_t USART_BRR_calculate(uint16_t baud_rate);
static void USART_set_stop_bit(uint16_t stop_bit);
static void USART_set_parity_bit(uint16_t parity_bit);
static void USART_set_BRR(uint16_t* baud_rate);

#define MB_BROADCAST_ADDRESS 0x0

#define FRAME_MAX_LENGTH 257u
#define FRAME_MIN_LENGTH 3u//see MODBUS over serial line specification and implementation guide V1.02. 6.1.2

#define UNICAST 1u
#define BROADCAST 0u

//### MODBUS Exception Responses ###
#define MB_ER_ILLEGAL_FUNCTION 0x01 //The function code received in the query is not an allowable action for the server
#define MB_ER_ILLEGAL_DATA_ADDRESS 0x02
#define MB_ER_ILLEGAL_DATA_VALUE 0x03
#define MB_ER_SERVER_DEVICE_FAILURE 0x04
#define MB_ER_ACKNOWLEDGE 0x05 
#define MB_ER_SERVER_DEVICE_BUSY 0x06
#define MB_ER_MEMORY_PARITY_ERROR 0x08
#define MB_ER_GATEWAY_PATH_UNAVAILABLE 0x0A
#define MB_ER_GATEWAY_TARGET_DEVICE_FAILED_TO_RESPOND 0x0B

#define MB_FUNC_FILED 0x80 //In an exception response, the server sets the MSB of the function code to 1. This makes the function codevalue in an exception response exactly 80 hexadecimal higher than the value would be for anormal response
#define MB_ER_LEN 0x05

//### MODBUS Function code ###
#define MB_FUNC_R_INPUT_DISCRETE 0x02
#define MB_FUNC_R_COILS_REG 0x01
#define MB_FUNC_R_INPUT_REG 0x04
#define MB_FUNC_R_HOLDING_REG 0x03
#define MB_FUNC_W_SINGLE_REG 0x06
#define MB_FUNC_W_SINGLE_COIL 0x05

#define MB_R_COILS_LEN 8u
#define MB_W_COIL_LEN 8u
#define MB_W_HOLDING_LEN 8u
#define MB_R_HOLDING_LEN (0x007D+CRC_LEN+2u) //максимальное кол-во регистров (125) +  сrc + адресс + од функции

typedef enum
{
  USART_BD_1200 = 12U, //12 — 1200 бит/с
  USART_BD_2400 = 24U, //24 — 2400 бит/с,
  USART_BD_4800 = 48U, //48 — 4800 бит/с,
  USART_BD_9600 = 96U, //96 — 9600 бит/с,
  USART_BD_19200 = 192U, //192 — 19 200 бит/с,
  USART_BD_38400 = 384U, //384 — 38 400 бит/с,
  USART_BD_57600 = 576U, //576 — 57 600 бит/с,
  USART_BD_115200 = 1152U //1152 — 115 200 бит/с
} USART_baud_rate;

static uint16_t usart_slave_addr = MBDDATA_SLAVE_ADDR;   
static uint16_t usart_bd =MBDDATA_BAUD_RATE;
static uint16_t usart_stop_bits = MBDDATA_STOP_BIT;
static uint16_t usart_parity_bit = MBDDATA_PARITY_BIT;
static bool busy_flag=0x0;

static struct modbus_frame
{
    uint8_t bytes[FRAME_MAX_LENGTH];
    uint16_t length; //текущая длина bytes[FRAME_MAX_LENGTH]
    bool length_eror_flag; //если приняли больше FRAME_MAX_LENGTH
    bool idle_3_5_ch_flag; //если на шине тишина в течении байт 
    bool idle_1_5_ch_flag; 
    bool frame_successful; //ставим этот флаг если нету ошибок с длинами и таймингами, далее нужно роверять на адресс и чётность
    uint8_t* adr;
    uint8_t* func_code;
} mb_frame;

static void RE_DE_init_pin(void)
{
    RCC   -> IOPENR  |= RCC_IOPENR_GPIOAEN ;

    GPIOA -> MODER   &= ~GPIO_MODER_MODE8_1;
    GPIOA -> MODER   |= GPIO_MODER_MODE8_0; //General purpose output mode

    GPIOA -> OSPEEDR &= ~ GPIO_OSPEEDR_OSPEED8_1;
    GPIOA -> OSPEEDR &= ~ GPIO_OSPEEDR_OSPEED8_0;//Very low speed

    GPIOA -> OTYPER  |= (GPIO_OTYPER_OT8); //open drain
    GPIOA -> PUPDR   &= ~(GPIO_PUPDR_PUPD8_1); //pullup
    GPIOA -> PUPDR   |= (GPIO_PUPDR_PUPD8_0);

    RE_DE_set_pin(0u);

    return;
}

static void RE_DE_set_pin(bool state)
{
    if(state!=0){
        GPIOA -> ODR |=GPIO_ODR_OD8;
    }else{
        GPIOA -> ODR &= ~GPIO_ODR_OD8;
    }
    return;
}

/**
   @brief init func 
 */
void uart_modbus_init(void)
{
    mb_frame.length=0;
    mb_frame.bytes[0]=0;
    mb_frame.length_eror_flag=0;
    mb_frame.idle_3_5_ch_flag=0;
    mb_frame.idle_1_5_ch_flag=0;
    mb_frame.frame_successful=0;
    mb_frame.adr=&mb_frame.bytes[0];
    mb_frame.func_code=&mb_frame.bytes[1];

    RE_DE_init_pin();

    RCC->APBENR2 |= RCC_APBENR2_USART1EN; // Включаем тактирование UART2
    RCC-> IOPENR  |= RCC_IOPENR_GPIOBEN ; // Включаем тактирование GpioB

    //Настройка PB3 как TX и PB7 как RX
    GPIOB->MODER &= ~(GPIO_MODER_MODE6_0 | GPIO_MODER_MODE7_0); // Режим альтернативной функции
    GPIOB->MODER |= (GPIO_MODER_MODE6_1 | GPIO_MODER_MODE7_1);  // Установить режим альтернативной функции

    GPIOB -> OTYPER  |= (GPIO_OTYPER_OT6 | GPIO_OTYPER_OT7); //open drain
    GPIOB -> PUPDR   &= ~(GPIO_PUPDR_PUPD6_1 |GPIO_PUPDR_PUPD7_1); //pullup
    GPIOB -> PUPDR   |=(GPIO_PUPDR_PUPD6_0|GPIO_PUPDR_PUPD7_0);
   
    //GPIOB->AFR[0] &= ~ (GPIO_AFRL_AFSEL6 | GPIO_AFRL_AFSEL7); // Установить альтернативную функцию AF1 для PA2 и PA3

    // Настройка скорости GPIO
    GPIOB->OSPEEDR &= ~(GPIO_OSPEEDR_OSPEED6 | GPIO_OSPEEDR_OSPEED7); // Настройка на очень низкую скорость

    USART1->ICR |= USART_ICR_TCCF; //Transmission Complete Clear Flag

    USART_set_BRR(&usart_bd);
    USART1->CR1 = 0u; // Сбрасываем регистр CR1
    USART_set_parity_bit(usart_parity_bit); 
    USART1->CR1 |= USART_CR1_TE | USART_CR1_RE; // Разрешаем передатчик и приемник
    //USART1->CR1 |= USART_CR1_DEAT_1 | USART_CR1_DEDT_1; //rs485 flow contol timing
    USART1->CR1 |= USART_CR1_RTOIE ; //USART interrupt generated when the RTOF bit is set in the USART_ISR register.
    USART1->CR1 |= USART_CR1_TCIE; //Transmission Complete Interrupt Enable
    USART1->CR2 = 0u; // Сбрасываем регистр CR2
    USART_set_stop_bit(usart_stop_bits);
    USART1->CR2 |= USART_CR2_SWAP; //инверсия tx-rx
    USART1->CR2 |= USART_CR2_RTOEN; //Receiver timeout feature enabled.
    USART1->CR3 = 0u; // Сбрасываем регистр CR3
    //USART1->CR3 |= USART_CR3_DEM; //DE function is enabled. The DE signal is output on the RTS pin.

    USART1->ICR |= USART_ICR_TCCF; //Transmission Complete Clear Flag

    //#####DMA#####
    USART1->CR3 |= USART_CR3_DMAR; //DMA Enable Receiver
    USART1->CR3 |= USART_CR3_DMAT; //DMA Enable Transmitter

    USART1->RTOR = 22u; //Receiver timeout value

    //#####DMA#####
    RCC->AHBENR  |= RCC_AHBENR_DMA1EN; //включаем тактирование 
    DMA1_Channel3->CPAR = (&(USART1->RDR)); //указатель на приёмник
    DMA1_Channel3->CMAR = mb_frame.bytes; //адресс на начало буфера
    DMA1_Channel3->CNDTR = FRAME_MAX_LENGTH&DMA_CNDTR_NDT; //кол-во байт по которому сработает прерывание
    DMA1_Channel3->CCR |= (DMA_CCR_PL  //priority level hery high
                        | DMA_CCR_MINC //memory increment mode enable
                        | DMA_CCR_TCIE //transfer complete interrupt enable
                        | DMA_CCR_TEIE); //transfer eror interrupt enable

    DMA1_Channel2->CPAR = (&(USART1->TDR)); //указатель на передатчик
    DMA1_Channel2->CMAR = mb_frame.bytes; //адресс на начало буфера
    DMA1_Channel2->CNDTR = 0; //счётчик
    DMA1_Channel2->CCR |= (DMA_CCR_PL  //priority level hery high
                        | DMA_CCR_MINC //memory increment mode enable
                        | DMA_CCR_TCIE //transfer complete interrupt enable
                        | DMA_CCR_TEIE
                        | DMA_CCR_DIR); //Data transfer direction

    #define DMAREQ_ID_USART1_RX 50u
    #define DMAREQ_ID_USART1_TX 51u
    DMAMUX1_Channel2->CCR = (DMAREQ_ID_USART1_RX&DMAMUX_CxCR_DMAREQ_ID);
    DMAMUX1_Channel1->CCR = (DMAREQ_ID_USART1_TX&DMAMUX_CxCR_DMAREQ_ID);
    NVIC_SetPriority(DMA1_Channel2_3_IRQn, MODBUS_IRQ_PIOITY_LEVEL);
    NVIC_EnableIRQ(DMA1_Channel2_3_IRQn);
    DMA1_Channel3->CCR |= DMA_CCR_EN; //enable DMA

    USART1->CR1 |= USART_CR1_UE; // Включаем USART

    NVIC_SetPriority(USART1_IRQn, MODBUS_IRQ_PIOITY_LEVEL);
    NVIC_EnableIRQ(USART1_IRQn);

    #ifdef DEBUG
    xprintf("baud rate = %d\n",usart_bd);
    xprintf("usart_stop_bits = %d\n",usart_stop_bits);
    xprintf("usart_parity_bit = %d\n",usart_parity_bit);
    xprintf("usart_slave_addr = 0x%x\n",usart_slave_addr);
    #endif

    return;
}

/**
    @brief проверка на занятость драйвера
    @return 0x1 в случае если драйвер занят (идёт обмен по уарт)
 */
bool MBRF_check_transfer_not_completed(void)
{
    return busy_flag;
}

uint8_t MBRF_modbus_init(void)
{
    uint8_t MB_init_eror = 0u;

    MB_init_eror+=MBRF_create_reg(MBADDR_BAUD_RATE, &usart_bd, MBTYPE_BAUD_RATE); //0x006E 
    MB_init_eror+=MBRF_create_reg(MBADDR_PARITY_BIT, &usart_parity_bit, MBTYPE_PARITY_BIT); //0x006F 
    MB_init_eror+=MBRF_create_reg(MBADDR_STOP_BIT, &usart_stop_bits, MBTYPE_STOP_BIT); //0x0070 
    MB_init_eror+=MBRF_create_reg(MBADDR_SLAVE_ADDR, &usart_slave_addr, MBTYPE_SLAVE_ADDR); //0x0080  

    return MB_init_eror;
}

static void USART_set_parity_bit(uint16_t parity_bit)
{
    if(parity_bit==1u)
    {
        USART1->CR1 |= ( USART_CR1_PCE | USART_CR1_M0 | USART_CR1_PS );
    }else if (parity_bit==2u)
    {
        USART1->CR1 |= ( USART_CR1_PCE | USART_CR1_M0 );
        USART1->CR1 &= ~ ( USART_CR1_PS );
    }else{
        USART1->CR1 &= ~ ( USART_CR1_PCE | USART_CR1_M0 | USART_CR1_PS );
    }
    return;
}

static void USART_set_stop_bit(uint16_t stop_bit)
{
    uint32_t ret =0;
    if(stop_bit!=1u)
    {
        USART1->CR2 |= USART_CR2_STOP_1;
    }else{
        USART1->CR2 &= ~ USART_CR2_STOP_1;
    }
    return;
}

static void USART_set_BRR(uint16_t* baud_rate)
{
    switch (*baud_rate) {
    case USART_BD_1200:
        USART1->BRR = (P_SYSCLK/((USART_BD_1200*100u))+1u);
        break;
    case USART_BD_2400:
        USART1->BRR = (P_SYSCLK/((USART_BD_2400*100u))+1u);
        break;
    case USART_BD_4800:
        USART1->BRR = (P_SYSCLK/((USART_BD_4800*100u))+1u);
        break;
    case USART_BD_9600:
        USART1->BRR = (P_SYSCLK/((USART_BD_9600*100u))+1u);
        break;
    case USART_BD_19200:
        USART1->BRR = (P_SYSCLK/((USART_BD_19200*100u))+1u);
        break;
    case USART_BD_38400:
        USART1->BRR = (P_SYSCLK/((USART_BD_38400*100u))+1u);
        break;
    case USART_BD_57600:
        USART1->BRR = (P_SYSCLK/((USART_BD_57600*100u))+1u);
        break; 
    case USART_BD_115200:
        USART1->BRR = (P_SYSCLK/((USART_BD_115200*100u))+1u);
        break;                                      
    default:
        *baud_rate = MBDDATA_BAUD_RATE;
        USART1->BRR = (P_SYSCLK/((MBDDATA_BAUD_RATE*100u))+1u); //9600 в случае остального
        break;
    }
    return;
}

extern void DMA1_Channel2_3_IRQHandler(void)
{
    
    if(DMA1->ISR & DMA_ISR_TCIF3 )
    {
        DMA1->IFCR |= DMA_IFCR_CTCIF3;
        MB_DMA_rx_start(FRAME_MAX_LENGTH);
        mb_frame.length=0;
        mb_frame.length_eror_flag=1;
    }
    if(DMA1->ISR & DMA_ISR_TEIF3)
    {
        DMA1->IFCR |= DMA_IFCR_CTEIF3;
        MB_DMA_rx_start(FRAME_MAX_LENGTH);
        mb_frame.length=0;
        mb_frame.length_eror_flag=1;
    }

    if(DMA1->ISR & DMA_ISR_TCIF2 )
    {
        DMA1->IFCR |= DMA_IFCR_CTCIF2;
        DMA1_Channel2->CCR &= ~DMA_CCR_EN;
    }
    if(DMA1->ISR & DMA_ISR_TEIF2)
    {
        DMA1->IFCR |= DMA_IFCR_CTEIF2;
        DMA1_Channel2->CCR &= ~DMA_CCR_EN;
    }
    return;
}

extern void USART1_IRQHandler(void)
{
    if(USART1->ISR&USART_ISR_RTOF)  //timeoit flag
    {
        USART1->ICR |= USART_ICR_RTOCF; //чистим флаг
        mb_frame.idle_3_5_ch_flag=1;
        mb_frame.length=FRAME_MAX_LENGTH-(DMA1_Channel3->CNDTR)&DMA_CNDTR_NDT;
        MB_DMA_rx_start(FRAME_MAX_LENGTH);
    }
    if((USART1->ISR&USART_ISR_TC))  //Transmission Complete Interrupt Enable
    {
        USART1->ICR |= USART_ICR_TCCF; //чистим флаг
        USART_set_BRR(&usart_bd);
        USART_set_parity_bit(usart_parity_bit); 
        USART_set_stop_bit(usart_stop_bits);
        RE_DE_set_pin(0);
        busy_flag=0x0;
    }
    return;
}

void modbus_periodic_work(void)
{
    bool unicast_flag;
    if(MB_check_request(&unicast_flag))
    {
        MB_response_handler(unicast_flag);
    }
    return;
}

static bool MB_check_request(bool *unicast_flag)
{
    bool ret=0;
    do{
        if( (mb_frame.length_eror_flag)!=0u )
        { 
            mb_frame.length_eror_flag=0u;
            break;
        }

        if( (mb_frame.idle_1_5_ch_flag)!=0u ) 
        {
            mb_frame.idle_1_5_ch_flag=0u;
            break;
        }

        if((mb_frame.idle_3_5_ch_flag)!=1u)
        {
            break;
        }

        if(mb_frame.length<FRAME_MIN_LENGTH)
        {
            break;
        }

        if(CRC_check(mb_frame.bytes, mb_frame.length)!=true)
        {
            break;
        }

        if(*mb_frame.adr==(uint8_t)usart_slave_addr)
        {
            ret=1;
            *unicast_flag=UNICAST;
        }else if (*mb_frame.adr==MB_BROADCAST_ADDRESS)
        {
            ret=1;
            *unicast_flag=BROADCAST;
        }
    }while(0u);

    return ret;
}


static void MB_response_handler(bool unicast_flag)
{
    uint16_t tx_len=0;
    switch (*mb_frame.func_code) {
    case MB_FUNC_R_HOLDING_REG:
        tx_len=MB_make_frame_r_u16(MBR_holding);
        break;
    case MB_FUNC_R_COILS_REG:
        tx_len=MB_make_frame_r_bool(MBR_coils);
        break;
    case MB_FUNC_R_INPUT_REG:
        tx_len=MB_make_frame_r_u16(MBR_input);
        break;
    case MB_FUNC_R_INPUT_DISCRETE:
        tx_len=MB_make_frame_r_bool(MBR_input_discrete);
        break;
    case MB_FUNC_W_SINGLE_COIL:
        tx_len=MB_make_frame_w(MBR_coils);
        break;
    case MB_FUNC_W_SINGLE_REG:
        tx_len=MB_make_frame_w(MBR_holding);
        break;
    default:
        tx_len=MB_make_frame_eror(MB_ER_ILLEGAL_FUNCTION);
        break;
    }
    if((tx_len>=FRAME_MIN_LENGTH)&&(unicast_flag!=BROADCAST))
    {
        MB_DMA_tx_start(tx_len);
    }
    return;
}

static void MB_DMA_rx_start(uint16_t len)
{
    DMA1_Channel3->CCR &=~ DMA_CCR_EN; //enable DMA
    DMA1_Channel3->CNDTR = len;
    DMA1_Channel3->CCR |= DMA_CCR_EN; //enable DMA
    return;
}

static void MB_DMA_tx_start(uint16_t len)
{
    busy_flag=0x1;
    RE_DE_set_pin(1u);
    DMA1_Channel2->CNDTR = len;         /*Set number of bytes to transmit*/
    DMA1_Channel2->CCR |= DMA_CCR_EN;         /*Enable Tx DMA channel*/
    return;
}

#define MB_FUNC_BYTE 0x2
static uint8_t MB_make_frame_eror(uint8_t er_code)
{
    uint8_t ret = 0; //если не  UNICAST возвращаем 0
    ret = MB_ER_LEN;
    *mb_frame.func_code+=MB_FUNC_FILED;
    mb_frame.bytes[MB_FUNC_BYTE]=er_code; //код функции 
    CRC_get(mb_frame.bytes, MB_ER_LEN,&mb_frame.bytes[MB_ER_LEN-2],&mb_frame.bytes[MB_ER_LEN-1]);
    return ret;
}

static uint8_t MB_make_frame_w(MBR_reg_type reg_type)
{
    uint8_t ret =0;
    uint16_t data_buf = (uint16_t)(mb_frame.bytes[4]<<8)+mb_frame.bytes[5]; //magic num
    uint16_t reg_adr = (uint16_t)(mb_frame.bytes[2]<<8)+mb_frame.bytes[3]; //magic num
    if(MB_W_HOLDING_LEN!=mb_frame.length)
    {
        ret = MB_make_frame_eror(MB_ER_ILLEGAL_DATA_VALUE);
    }else
    {
        if(MBR_OK==MBRF_write_reg(reg_adr,data_buf,reg_type))
        {
            ret = mb_frame.length; //т.к. в случае успешной заиси мы должны вернуть тоже самое, не переисывает буфер вообще
        }else
        {
            ret = MB_make_frame_eror(MB_ER_ILLEGAL_DATA_ADDRESS);
        }
    }
    return ret;
}

static uint8_t MB_make_frame_r_u16( MBR_reg_type reg_type)
{
    uint8_t ret =0u;
    uint16_t data_buf;
    uint16_t reg_adr_start = (uint16_t)(mb_frame.bytes[2u]<<8u)+mb_frame.bytes[3u]; //magic num
    uint16_t reg_num = (uint16_t)mb_frame.bytes[5u]; //magic num
    if(mb_frame.length>MB_R_HOLDING_LEN)
    {
        ret = MB_make_frame_eror(MB_ER_ILLEGAL_DATA_VALUE);
    }else
    {
        if(MBR_OK==MBRF_multiple_read_reg(reg_adr_start, reg_num, &mb_frame.bytes[3u], reg_type))
        {
            mb_frame.bytes[2u]=2*(reg_num);
            CRC_get(mb_frame.bytes, 5u+(reg_num*2u),&mb_frame.bytes[5u+((reg_num-1)*2)],&mb_frame.bytes[6u+((reg_num-1)*2)]);
            ret = 5u+(reg_num*2); 
        }else
        {
            ret = MB_make_frame_eror(MB_ER_ILLEGAL_DATA_ADDRESS);
        }
    }
    return ret;
}

static uint8_t MB_make_frame_r_bool(MBR_reg_type reg_type)
{
    uint8_t ret =0u;
    uint16_t data_buf;
    uint16_t reg_adr_start = (uint16_t)(mb_frame.bytes[2u]<<8u)+mb_frame.bytes[3u]; //magic num
    uint16_t reg_num = (uint16_t)mb_frame.bytes[5u]; //magic num
    if(mb_frame.length>MB_R_HOLDING_LEN)
    {
        ret = MB_make_frame_eror(MB_ER_ILLEGAL_DATA_VALUE);
    }else
    {
        if(MBR_OK==MBRF_multiple_read_reg_bool(reg_adr_start, reg_num, &mb_frame.bytes[3u], reg_type))
        {
            reg_num=(reg_num/8u)+((reg_num%8u)!=0);
            mb_frame.bytes[2u]=(reg_num);
            CRC_get(mb_frame.bytes, 5u+(reg_num),&mb_frame.bytes[3u+reg_num],&mb_frame.bytes[4u+reg_num]);
            ret = 5u+(reg_num); 
            // mb_frame.bytes[2u]=(reg_num);
            // CRC_get(mb_frame.bytes, 5u+(reg_num),&mb_frame.bytes[3u+reg_num],&mb_frame.bytes[4u+reg_num]);
            // ret = 5u+(reg_num); 
        }else
        {
            ret = MB_make_frame_eror(MB_ER_ILLEGAL_DATA_ADDRESS);
        }
    }
    return ret;
}