#include "platform.h"

#define WATCHDOG 1u

#define START_KEY (uint32_t)0xCCCC
#define ENABLE_ACCES_KEY (uint32_t)0x5555
#define REFRESH_VALUE (uint32_t)0xAAAA

/**
    @brief инициализируем собаку
    @brief 0,5 без вызова refresh перезагружает МК
 */
void watchdog_init(void)
{
	IWDG -> KR = START_KEY&IWDG_KR_KEY ; //Writing the key value 0xCCCC starts the watchdog 
	IWDG -> KR = ENABLE_ACCES_KEY&IWDG_KR_KEY ; //Writing the key value 0x5555 to enable access to the IWDG_PR, IWDG_RLR and IWDG_WINR registers
	IWDG -> PR |= 0x100; //divider /64
	IWDG -> PR |= 0x1; //0.5 секунд
	while( (IWDG -> SR) != (uint32_t)(0x0) ) //Wait for the registers to be updated (IWDG_SR = 0x0000 0000)
	{
		NOP();
	}

	return;
}

/**
    @brief обновить пса
*/
void watchdog_refresh(void)
{
	IWDG -> KR = REFRESH_VALUE&IWDG_KR_KEY ; //Refresh the counter value 
	return;
}
