
SHELL=/bin/bash

# Проверяем, задана ли переменная CPPTEST
# Поместить export CPPUTEST="/home/developer/Programs/cpputest в .bashrc"
ifeq ($(strip $(CPPUTEST)),)
    $(error Переменная CPPTEST не задана)
endif

CPPUTEST_HOME = $(CPPUTEST)

include $(DIR_MK)/settings.mk

## CppUTest configurations ##


COMPONENT_NAME = ./build/utest_s/test-template
# COMPONENT_NAME = ./$(MC_UTESTS)

CPPUTEST_ENABLE_DEBUG = Y
CPPUTEST_USE_EXTENSIONS = Y
CPP_PLATFORM = Gcc
CPPUTEST_USE_GCOV = Y
CPPUTEST_OBJS_DIR = build/utest_s/obj
CPPUTEST_LIB_DIR = build/utest_s/lib
# CPPUTEST_OBJS_DIR = $(MC_UTESTS_OUTPATH_OBJS)
# CPPUTEST_LIB_DIR = $(MC_UTESTS_OUTPATH_LIB)

SRC_DIRS = $(MC_UTESTS_PATHS_SRC)

TEST_SRC_DIRS = $(MC_UTESTS_PATHS_TEST_SRC)

INCLUDE_TEST_DIRS = $(MC_UTESTS_PATHS_INCLUDES)
INCLUDE_DIRS = $(INCLUDE_TEST_DIRS)

CPPUTEST_CPPFLAGS = -DDISABLE_LOG -DUTEST_BUILD -DSTM32G030xx
CPPUTEST_CXXFLAGS = -std=c++$(C_STANDART) -O0
CPPUTEST_LDFLAGS = -pthread 
CPPUTEST_WARNINGFLAGS = -Wall -Wextra -Wshadow -Wswitch-default -Wswitch-enum -Wconversion -Wno-long-long

## The real work ##
# including this file that will use configuration and have the make rules.



include $(CPPUTEST_HOME)/build/MakefileWorker.mk



